#---
# Excerpted from "Agile Web Development with Rails, 2nd Ed."
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails2 for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'
require 'dave99s_controller'

# Re-raise errors caught by the controller.
class Dave99sController; def rescue_action(e) raise e end; end

class Dave99sControllerTest < Test::Unit::TestCase
  fixtures :dave99s

  def setup
    @controller = Dave99sController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_should_get_index
    get :index
    assert_response :success
    assert assigns(:dave99s)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end
  
  def test_should_create_dave99
    old_count = Dave99.count
    post :create, :dave99 => { }
    assert_equal old_count+1, Dave99.count
    
    assert_redirected_to dave99_path(assigns(:dave99))
  end

  def test_should_show_dave99
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end
  
  def test_should_update_dave99
    put :update, :id => 1, :dave99 => { }
    assert_redirected_to dave99_path(assigns(:dave99))
  end
  
  def test_should_destroy_dave99
    old_count = Dave99.count
    delete :destroy, :id => 1
    assert_equal old_count-1, Dave99.count
    
    assert_redirected_to dave99s_path
  end
end
