#---
# Excerpted from "Agile Web Development with Rails, 2nd Ed."
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails2 for more book information.
#---
require File.dirname(__FILE__) + '/../test_helper'
require 'daves_controller'

# Re-raise errors caught by the controller.
class DavesController; def rescue_action(e) raise e end; end

class DavesControllerTest < Test::Unit::TestCase
  fixtures :daves

  def setup
    @controller = DavesController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new
  end

  def test_should_get_index
    get :index
    assert_response :success
    assert assigns(:daves)
  end

  def test_should_get_new
    get :new
    assert_response :success
  end
  
  def test_should_create_dave
    old_count = Dave.count
    post :create, :dave => { }
    assert_equal old_count+1, Dave.count
    
    assert_redirected_to dave_path(assigns(:dave))
  end

  def test_should_show_dave
    get :show, :id => 1
    assert_response :success
  end

  def test_should_get_edit
    get :edit, :id => 1
    assert_response :success
  end
  
  def test_should_update_dave
    put :update, :id => 1, :dave => { }
    assert_redirected_to dave_path(assigns(:dave))
  end
  
  def test_should_destroy_dave
    old_count = Dave.count
    delete :destroy, :id => 1
    assert_equal old_count-1, Dave.count
    
    assert_redirected_to daves_path
  end
end
